openapi: "3.0.0"

info:
  title: Node Microservice
  license:
    name: MIT
    url: https://gitlab.com/abraham.tewa/starter.node.microservice/-/blob/main/LICENSE.md

  version: "1.0"

servers:
  - url: http://localhost:3000/api
    description: Default development server

paths:
  /status:
    get:
      operationId: getStatus
      responses:
        200:
          description: Will always return the text "OK"
          content:
            plain/text:
              example: "OK"

  /date:
    get:
      operationId: getDate
      responses:
        200:
          description: Will always return current date at ISO format
          content:
            application/json:
              schema:
                type: string
                format: date-time

  /user:
    post:
      operationId: createUser
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UserInsert'

      responses:
        200:
          description: 'OK'

  /user/{id}:
    get:
      operationId: getUser
      parameters:
        - name: id
          in: path
          required: true
          schema:
            type: number

      responses:
        200:
          description: 'OK'

components:
  schemas:
    User:
      type: object
      properties:
        id:
          type: number

        username:
          type: string

        lastModifiedAt:
          type: string
          format: date-time

        createdAt:
          type: string
          format: date-time

    UserInsert:
      type: object
      properties:
        username:
          type: string
